from collections import deque, defaultdict

def bfs(start, max_distance, graph, visited):
    queue = deque([start])
    distance = 0
    visited.add(start)
    
    while queue and distance < max_distance:
        for _ in range(len(queue)):
            current = queue.popleft()
            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append(neighbor)
        distance += 1

def main():
    n, m, k = map(int, input().split())
    
    # Построение графа
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)
    
    # Множество для хранения охраняемых складов
    protected_warehouses = set()
    
    # Обработка каждого охранника
    for _ in range(k):
        p, h = map(int, input().split())
        visited = set()
        bfs(p, h, graph, visited)
        protected_warehouses.update(visited)
    
    # Результат
    protected_warehouses = sorted(protected_warehouses)
    print(len(protected_warehouses))
    if protected_warehouses:
        print(' '.join(map(str, protected_warehouses)))
    else:
        print()

if __name__ == "__main__":
    main()
